<template>
    <div class="container-fluid">
        <div class="row clearfix">
            <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                <div class="card">
                    <div class="header">
                        <h2>
                            Edit Product
                        </h2>
                    </div>
                    <div class="body">
                        <form action="javascript:void(0)" ref="update" @submit="update" method="post">
                            <div class="row clearfix">
                                <div class="col-sm-12">
                                    <div class="form-group">
                                        <div class="form-line">
                                            <label for="name">Product Name</label>
                                            <input required v-model="product.name" id="name" type="text" name="name" class="form-control" placeholder="Name" />
                                        </div>
                                    </div>
                                    <div class="form-group form-float">
                                        <div class="form-line">
                                            <label for="category">Categories</label>
                                            <select required v-model="product.category_id" @change="subCategories" name="category_id" id="category" class="form-control show-tick">
                                                <option :value="null">Select one</option>
                                                <option v-for="category in categories" :key="category.id" :value="category.id">
                                                    {{category.name}}
                                                </option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="form-group form-float">
                                        <div class="form-line">
                                            <label for="sub_category">Sub Category</label>
                                            <select required @change="subSubCategories" v-model="product.sub_category_id" name="sub_category_id" id="sub_category" class="form-control show-tick" data-live-search="true">
                                                <option :value="null">Select one</option>
                                                <option v-for="sub_category in sub_categories" :key="sub_category.id" :value="sub_category.id">
                                                    {{sub_category.name}}
                                                </option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="form-group form-float">
                                        <div class="form-line">
                                            <label for="sub_sub_category">Sub Sub Category</label>
                                            <select required v-model="product.sub_sub_category_id" name="sub_sub_category_id" id="sub_sub_category" class="form-control show-tick" data-live-search="true">
                                                <option :value="null">Select one</option>
                                                <option v-for="sub_sub_category in sub_sub_categories" :key="sub_sub_category.id" :value="sub_sub_category.id">
                                                    {{sub_sub_category.name}}
                                                </option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="form-group form-float">
                                        <div class="form-line">
                                            <label for="brand">Brands</label>
                                            <select required v-model="product.brand_id" name="brand_id" id="brand" class="form-control show-tick" data-live-search="true">
                                                <option :value="null">Select one</option>
                                                <option v-for="brand in brands" :key="brand.id" :value="brand.id">
                                                    {{brand.name}}
                                                </option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="form-group form-float">
                                        <div class="form-line">
                                            <label for="size">Sizes</label>
                                            <select required v-model="sizes_id" name="sizes[]" multiple id="size" class="form-control show-tick" data-live-search="true">
                                                <option v-for="size in sizes" :key="size.id" :value="size.id">
                                                    {{size.name}}
                                                </option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="form-group form-float">
                                        <div class="form-line">
                                            <label for="color">Colors</label>
                                            <select required v-model="colors_id" name="colors[]" id="color" multiple class="form-control show-tick" data-live-search="true">
                                                <option v-for="color in colors" :key="color.id" :value="color.id">
                                                    {{color.name}}
                                                </option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <div class="form-line">
                                            <label for="image">Image</label>
                                            <input type="file" accept="image" @change="imgPrepare" id="image" name="image" ref="img" class="form-control" placeholder="Upload image" />
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <div class="form-line">
                                            <label for="price">Price</label>
                                            <input required v-model="product.price" type="number" name="price" id="price" class="form-control" placeholder="Price" />
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label for="description" class="form-label">Description</label>
                                        <textarea required class="form-control" v-model="product.description" placeholder="your description here" id="description" rows="6" name="description" style="outline: none !important;border-color: #719ECE;box-shadow: 0 0 10px #719ECE;"></textarea>
                                    </div>
                                    <div class="form-group">
                                        <label for="condition" class="form-label">Condition</label>
                                        <textarea required class="form-control" v-model="product.condition" placeholder="your condition here" id="condition" rows="6" name="condition" style="outline: none !important;border-color: #719ECE;box-shadow: 0 0 10px #719ECE;"></textarea>
                                    </div>
                                    <div class="form-group">
                                        <div>
                                            <a class="btn btn-danger m-t-15 waves-effect" @click="senderPage('productView')">Back</a>
                                            <input type="submit" value="Update" class="btn btn-primary"/>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
        <!-- #END# Input -->
    </div>
</template>
<script>
    export default {
        props:{
            product:{
                type: Object,
                required: true,
            },
        },
        data() {
            return{
                sizes_id:[],
                colors_id:[],
                categories:{},
                sub_categories:{},
                sub_sub_categories:{},
                brands:{},
                sizes:{},
                colors:{}
            }
        },
        created() {
            axios.get('/admin/product/all/info').then((response)=>{
                let data =response.data;
                this.categories=data.categories;
                this.brands=data.brands;
                this.sizes=data.sizes;
                this.colors=data.colors;
            }).catch((error)=>{
                this.categories={};
                this.brands={};
                this.sizes={};
                this.colors={};
            });
            this.subCategories();
            this.subSubCategories();
            this.product.sizes.forEach((value,key)=>{
                this.sizes_id.push(value.id);
            });
            this.product.colors.forEach((value,key)=>{
                this.colors_id.push(value.id);
            });
        },
        methods:{
            /*
            * method for get all sub categories
            * */
            subCategories(){
                axios.get(`/admin/product/sub/category/${this.product.category_id}`).then((response)=>{
                    this.sub_categories=response.data;
                    this.sub_sub_categories={};
                }).catch((error)=>{
                    this.sub_categories= {};
                    this.sub_sub_categories={};
                });
            },
            /*
            * method for get sub sub categories
            * */
            subSubCategories(){
                axios.get(`product/sub/sub/category/${this.product.sub_category_id}`).then((response)=>{
                    this.sub_sub_categories=response.data;
                }).catch((error)=>{
                    this.sub_sub_categories= {};
                });
            },
            senderPage(text){
                this.$emit('sent',text);
            },
            /*
            * method for prepare image for upload
            * */
            imgPrepare(){
                let files=this.$refs.img.files;
                if (files.length){
                    return files[0];
                }
                return null;
            },

            /*
            * method for update product information
            * */
            update(){
                let data = new FormData(this.$refs.update);
                data.append('image',this.imgPrepare());
                axios.post(`/admin/product/update${this.product.id}`,data)
                    .then((response) => {
                        this.$toaster.success(response.data);
                    }).catch((error)=>{
                    if (error.response.status === 422) this.$toaster.error(error.response.data.errors);
                    else this.$toaster.error(error);
                });
            }
        }
    }
</script>
